import type { AbyssBattleData } from "../interface";
import { BaseRoute, fetchOptions, Options } from "./base";
import type { ClientCache } from "../client/clientCache";
export type SpiralAbyssFetchOptions = fetchOptions & {
    previous?: boolean;
};
export declare class SpiralAbyss extends BaseRoute {
    cache: ClientCache<AbyssBattleData> | null;
    defaultOptions: SpiralAbyssFetchOptions;
    constructor(options?: Options<SpiralAbyssFetchOptions>);
    /**
     * @param {string} uid Genshin Impact UID
     */
    fetch(uid: string, options?: SpiralAbyssFetchOptions): Promise<AbyssBattleData>;
}
