import type { CharacterData, CharacterInfoData } from "../interface";
import { BaseRoute, fetchOptions, Options } from "./base";
import type { ClientCache } from "../client/clientCache";
export declare class Charcters extends BaseRoute {
    cache: ClientCache<CharacterData[]> | null;
    private readonly defaultOptions?;
    constructor(options?: Options<fetchOptions>);
    /**
     * @param {string} uid Genshin Impact UID
     */
    fetch(uid: string, options?: fetchOptions): Promise<CharacterData[]>;
    /**
     * @param {number} characterId The avatar's id
     */
    fetchAvatarInfo(characterId: number, options?: fetchOptions): Promise<CharacterInfoData>;
}
